package fitconnect.impl.auth;

import fitconnect.api.Sender;
import fitconnect.api.domain.auth.OAuthToken;
import fitconnect.impl.SubmissionSender;
import org.junit.jupiter.api.Test;

import java.net.http.HttpClient;
import java.util.Optional;

import static org.junit.jupiter.api.Assertions.*;

class OAuthTokenIntegrationTest {

    @Test
    void retrieveAuthenticationToken() {

        // Given
        var tokenUrl = "https://auth-testing.fit-connect.fitko.dev/token";
        var clientId = "781f6213-0f0f-4a79-9372-e7187ffda98b";
        var secret = "PnzR8Vbmhpv_VwTkT34wponqXWK8WBm-LADlryYdV4o";
        var scope = "send:region:DE";

        var httpClient = HttpClient.newHttpClient();
        var authService = new FitCoAuthService(httpClient, tokenUrl);
        final Sender sender = new SubmissionSender(authService, null, null);

        // When
        Optional<OAuthToken> token = sender.retrieveOAuthToken(clientId, secret, scope);

        // Then

        assertTrue(token.isPresent());
        assertNull(token.get().getError());
        assertNotNull(token.get().getAccessToken());
        assertEquals(1800, token.get().getExpiresIn());
    }
}